/*
 * SPDX-FileCopyrightText: 2021-2022 Espressif Systems (Shanghai) CO LTD
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#include <string.h>
#include <stdio.h>
#include "sdkconfig.h"
#include "esp_log.h"
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/semphr.h"
#include "beatz_adc.h"

extern TaskHandle_t control_adc_task_h;
extern TaskHandle_t eval_adc_task_h;

void app_main(void)
{
    xTaskCreate(vEvaluateADC, "Evaluate ADC", 4*1024, NULL, 1, &eval_adc_task_h);
    xTaskCreate(vControlADC, "Control ADC", 2*1024, NULL, 1, &control_adc_task_h);
    configASSERT(control_adc_task_h);
    configASSERT(eval_adc_task_h);
    vTaskSuspend(xTaskGetCurrentTaskHandle());
    ESP_LOGE("Error", "This shouldn't be executed");
    for(;;){
    }
}
