#include "beatz_pwm.h"
#include <stdio.h>
#include "driver/ledc.h"
#include "esp_err.h"
#include "beatz_adc.h"
#include "esp_log.h"

int pwm_pin_pattern[CH_NUM] = {GPIO_NUM_10, GPIO_NUM_11, GPIO_NUM_12, GPIO_NUM_13, GPIO_NUM_14, GPIO_NUM_15, GPIO_NUM_16, GPIO_NUM_17};

void pwm_initialize(void)
{
    // Prepare and then apply the LEDC PWM timer configuration
    ledc_timer_config_t pwm_timer = {
        .speed_mode       = SPEED_MODE,
        .timer_num        = PWM_TIMER,
        .duty_resolution  = PWM_DUTY_RES,
        .freq_hz          = PWM_FREQ,
        .clk_cfg          = LEDC_AUTO_CLK
    };
    ESP_ERROR_CHECK(ledc_timer_config(&pwm_timer));

    // Prepare and then apply the LEDC PWM channel configuration
    ledc_channel_config_t ledc_channel = {
        .speed_mode     = SPEED_MODE,
        .channel        = PWM_CHANNEL,
        .timer_sel      = PWM_TIMER,
        .intr_type      = LEDC_INTR_DISABLE,
        .gpio_num       = PWM_OUTPUT_IO,
        .duty           = 0, // Set duty to 0%
        .hpoint         = 0
    };
    ESP_ERROR_CHECK(ledc_channel_config(&ledc_channel));
}

void pwm_configure(int idx)
{
    //ESP_LOGW("PWM", "PWM IO: %d", pwm_pin_pattern[idx]);
    ledc_set_pin(pwm_pin_pattern[idx], SPEED_MODE, PWM_CHANNEL);
}

void pwm_start(void)
{
    ESP_ERROR_CHECK(ledc_set_duty(SPEED_MODE, PWM_CHANNEL, PWM_DUTY));
    ESP_ERROR_CHECK(ledc_update_duty(SPEED_MODE, PWM_CHANNEL));
}